﻿
-- My Garrison is Done --
-- Written by Jaxom of Hellfire --
-- Based on an Idea by Cederra of Hellfire, He helps test my addons and this was his idea. --
-- GNU General Public License version 3 (GPLv3) --

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

-- DEFAULTS --

local playerName = UnitName("player");
local character = UnitName("player").."-"..GetRealmName();
local guildName = GetGuildInfo("player");    
local self = GarrisonDone;
local DCF = DEFAULT_CHAT_FRAME;


-- ON LOAD --

function GarrisonDone_OnLoad()

    
-- START --
        -- Assign Tabs for future second Tab to show alts --
        -- PanelTemplates_SetNumTabs(GarrisonDoneFrame, 2);  -- 2 = frames total. --
        -- PanelTemplates_SetTab(GarrisonDoneFrame, 1);      -- 1 = tab 1 selected. --
        
        
-- LOCK FRAME SIZE SETTINGS --
        
        GarrisonDoneFrame:SetMinResize(195,245);
        GarrisonDoneFrame:SetMaxResize(195,245);
        
-- REGISTER EVENTS --
        
        GarrisonDone:RegisterEvent("VARIABLES_LOADED");
        GarrisonDone:RegisterEvent("STORETEXT");
        GarrisonDone:RegisterEvent("ONTEXTCHANGED");
        GarrisonDone:RegisterEvent("UPDATE");
        GarrisonDone:RegisterEvent("GETTEXT");
        GarrisonDone:RegisterEvent("SETTEXT");
        GarrisonDone:RegisterEvent("ONFOCUS");
        GarrisonDone:RegisterEvent("SETFOCUS");
        GarrisonDone:RegisterEvent("CLEARFOCUS");
        GarrisonDone:RegisterEvent("ONSHOW");
        GarrisonDone:RegisterEvent("ONHIDE");
        GarrisonDone:RegisterEvent("ONCLICK");
        GarrisonDone:RegisterEvent("ZONE_CHANGED");
        GarrisonDone:RegisterEvent("ZONE_CHANGED_INDOORS");
        GarrisonDone:RegisterEvent("ZONE_CHANGED_NEW_AREA");
        GarrisonDone:RegisterEvent("REGISTERFORDRAG");
        GarrisonDone:RegisterEvent("GARRISON_UPDATE");
        GarrisonDone:RegisterEvent("GARRISON_FOLLOWER_WORKING");
        GarrisonDone:RegisterEvent("GARRISON_MISSION_LIST_UPDATE");
        GarrisonDone:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
        GarrisonDone:RegisterEvent("GARRISON_MISSION_STARTED");
        GarrisonDone:RegisterEvent("GARRISON_MISSION_FINISHED");
        GarrisonDone:RegisterEvent("CHAT_MSG_SYSTEM");
	    GarrisonDone:RegisterEvent("GARRISON_FOLLOWER_ADDED");
	    GarrisonDone:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE");
	    GarrisonDone:RegisterEvent("GARRISON_FOLLOWER_REMOVED");
	    GarrisonDone:RegisterEvent("GARRISON_HIDE_LANDING_PAGE");
	    GarrisonDone:RegisterEvent("GARRISON_MISSION_NPC_CLOSED");
	    GarrisonDone:RegisterEvent("GARRISON_MISSION_NPC_OPENED");
	    GarrisonDone:RegisterEvent("GARRISON_SHOW_LANDING_PAGE");
        GarrisonDone:RegisterEvent("PLAYER_ENTERING_WORLD");
	    
        
	    table.insert(UISpecialFrames,"GarrisonDoneFrame");     
        
-- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
        SLASH_GARRISONDONE2 = "/gdone";
end
        
    -- Set Default Variables --

function GarrisonDone_Loaded()
    if GarrisonDone_Varsc == nil then
        GarrisonDone_Varsc = SimpleNotepad_Defaults
        DEFAULT_CHAT_FRAME:AddMessage("My Garrison found no database. Generating Defaults...");
        end
    if (GarrisonDone_Varsc["version"] < GarrisonDone_Version) then
        GarrisonDone_Varsc_temp = GarrisonDone_Defaults;
        for k,v in GarrisonDone_Varsc do
    if (GarrisonDone_Defaults["Vars"][k]) then
        GarrisonDone_Varsc_temp[k] = v;
        end
    end
        GarrisonDone_Varsc_temp["version"] = GarrisonDone_Version;
        GarrisonDone_Varsc = GarrisonDone_Varsc_temp;
    end
    
    for k, v in pairs({
	    "CHAT_MSG_SYSTEM",
	    "GARRISON_FOLLOWER_ADDED",
	    "GARRISON_FOLLOWER_LIST_UPDATE",
	    "GARRISON_FOLLOWER_REMOVED",
	    "GARRISON_HIDE_LANDING_PAGE",
	    "GARRISON_MISSION_NPC_CLOSED",
	    "GARRISON_MISSION_NPC_OPENED",
	    "GARRISON_SHOW_LANDING_PAGE",
	    "GARRISON_UPDATE",
	}) 
    do GarrisonDone_OnEvent:RegisterEvent(v) 
    end
end

    -- Function - Load Variables and fire it up :) --

-- EVENT FUNCTIONS --

function GarrisonDone_OnEvent(event, self, ...)
        if event == "VARIABLES_LOADED" then
            
        GarrisonDone_Varsc.version = tostring(GarrisonDone_Varsc.version);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.version = "";
		end
            
		GarrisonDone_Varsc.character = tostring(GarrisonDone_Varsc.character);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character = "";
		end
        
        GarrisonDone_Varsc.character.miningLeft = tonumber(GarrisonDone_Varsc.character.miningLeft);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character.miningLeft = "";
		end
        
        GarrisonDone_Varsc.character.maxMining = tonumber(GarrisonDone_Varsc.character.maxMining);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character.maxMining = "";
		end
        
        GarrisonDone_Varsc.character.herbingLeft = tonumber(GarrisonDone_Varsc.character.herbingLeft);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character.herbingLeft = "";
		end
        
        GarrisonDone_Varsc.character.maxHerbing = tonumber(GarrisonDone_Varsc.character.maxHerbing);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character.maxHerbing = "";
		end        
        
        GarrisonDone_Varsc.character.lastLogin = tostring(GarrisonDone_Varsc.character.lastLogin);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.character.lastLogin = "";
		end
		
		GarrisonDone_Varsc.reference = tostring(GarrisonDone_Varsc.reference);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.reference = "";
		end
        
        GarrisonDone_Varsc.nodes = tostring(GarrisonDone_Varsc.nodes);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.nodes = "";
		end
        
        GarrisonDone_Varsc.auto = tostring(GarrisonDone_Varsc.auto);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.auto = "";
		end
       
    -- Set Table to look for Herbs and Ore --  
		
        if(not table.contains) then
	    function table.contains(table, element)
  		for _, value in pairs(table) do
	    	if value == element then
	      		return true
	    	end
	  	end
	  	return false
	end
end
       
       
        GarrisonDone_InGarrison();
        GarrisonDone_CompLogin(self, when)
        GarrisonDone_Loaded();
        GarrisonDone_SetText();
    end
 end
 
 
-- Function - Is the Player in there Garrison, if there not we dont want to show --   

    -- SHOW FRAME IF IN GARRISON -- 
    
function GarrisonDone_InGarrison(self)
            -- this isnt working cause you wrote it a week ago to remind you Twerp --
	if (GarrisonDone_Varsc.auto == true) and (zoneName == Lunarfall) then
	    GarrisonDoneFrame:Show();
	else
		GarrisonDoneFrame:Hide();
		
	end
end

    -- SHOW FRAME --    
function GarrisonDone_OnShow(self)
    GarrisonDoneFrame:Show();
    GarrisonDone_Update();
    GarrisonDone_ScanFollowers();
    GarrisonDone_CompLogin(self, when);
    GarrisonDone_SetText();
end
        

    -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDoneFrame:IsVisible() then
		GarrisonDoneFrame:Hide();
	else
		GarrisonDoneFrame:Show();
	end
end

    -- MOVES FRAME --
function GarrisonDone_OnMouseDown(self)
    if Button == "RightButton" then
	    GarrisonDoneFrame:StartMoving();
    end
end

function GarrisonDone_OnMouseUp(self)
	if Button == "RightButton" then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end


-- REMOVES FRAME IF DISABLE TRUE --
function GarrisonDone_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end



    -- ON TEXT CHANGE we will probably need to do something here --
function GarrisonDone_OnTextChanged(self)
	
end

    -- Find all our Followers as they have id's unique to the player --
function GarrisonDone_ScanFollowers()

end

    -- Set timer for Ore and Herbs Reset --
function GarrisonDone_CompLogin(self, when)
	if not GarrisonDone_Varsc.lastLogin then
		GarrisonDone_Varsc.lastLogin = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
		GarrisonDone_Reset(self, when)
		return
	end
	local oldTime, oldResetTime = GarrisonDone_Varsc.lastLogin.time, GarrisonDone_Varsc.lastLogin.resetTime
	GarrisonDone_Varsc.lastLogin = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
	}
        -- it's more than a day or quest reset timer has popped --
	if (GarrisonDone_Varsc.lastLogin.time - oldTime > 86400) or (oldResetTime < GetQuestResetTime()) then 
		GarrisonDone_Reset(self, when)
	end
end

    -- find and Store Ore and Herbs --
function GarrisonDone_Reset(self, when)
	local mines = {61, 62, 63}
	local gardens = {29, 136, 137}
    local ores = {8, 13, 18}
	local herbs = {6, 10, 15}
	local ore, herb
	local buildings, myMine, myGarden = C_Garrison.GetBuildings()
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		for k, v in ipairs(mines) do
			if v == buildingID then
				myMine = v
			end
		end
		for k, v in ipairs(gardens) do
			if v == buildingID then
				myGarden = v
			end
		end
	end
	if myMine == 61 then
		GarrisonDone_Varsc.character.miningLeft = 8;
		GarrisonDone_Varsc.character.maxMining = 8;
		GarrisonDone_Varsc.character.hasMine = true;
    elseif myMine == 62 then
		GarrisonDone_Varsc.character.miningLeft = 13;
		GarrisonDone_Varsc.character.maxMining = 13;
		GarrisonDone_Varsc.character.hasMine = true;
    elseif myMine == 63 then
		GarrisonDone_Varsc.character.miningLeft = 18;
		GarrisonDone_Varsc.character.maxMining = 18;
		GarrisonDone_Varsc.character.hasMine = true;
    end
	if myGarden == 29 then
		GarrisonDone_Varsc.character.herbingLeft = 6;
		GarrisonDone_Varsc.character.maxHerbing = 6;
		GarrisonDone_Varsc.character.hasGarden = true;
    elseif myGarden == 136 then
		GarrisonDone_Varsc.character.herbingLeft = 10;
		GarrisonDone_Varsc.character.maxHerbing = 10;
		GarrisonDone_Varsc.character.hasGarden = true;
    elseif myGarden == 137 then
		GarrisonDone_Varsc.character.herbingLeft = 15;
		GarrisonDone_Varsc.character.maxHerbing = 15;
		GarrisonDone_Varsc.character.hasGarden = true;
	end
end
    
function GarrisonDone_DecrementNode(self, event, ...)
	 --   if which == "herb" then
	--	    GarrisonDone_Varsc.character.herbingLeft = GarrisonDone_Varsc.character.herbingLeft - 1
	 --   elseif which == "ore" then
	--	    GarrisonDone_Varsc.character.miningLeft = GarrisonDone_Varsc.character.miningLeft - 1
--	end	
end


-- TEXT FUNCTIONS --

function GarrisonDone_Update()
    -- Assign Local Variables straight from Blizz frame --
    local mgd = {
	[GARRISON_FOLLOWER_ON_MISSION] = true,
	[GARRISON_FOLLOWER_INACTIVE] = true,
    [GARRISON_FOLLOWER_WORKING] = true,
	}
    
    -- Max Followers --
    local maxFollowers = C_Garrison.GetFollowerSoftCap();
    
    -- Active Followers --
    local numActiveFollowers = C_Garrison.GetNumActiveFollowers();
   
    -- Followers working --
    local work = 0;
    if (GARRISON_FOLLOWER_WORKING == true) then  -- this isnt even close to what we need --
			work = work + 1
    elseif (GARRISON_FOLLOWER_WORKING == false) then
            work = 0;
    end
    
    -- Followers Available --
    local gfm = 0;
    if (GARRISON_FOLLOWER_ON_MISSION == true) then  -- this isnt even close to what we need --
        gfm = gfm + 1
    elseif (GARRISON_FOLLOWER_ON_MISSION == false) then
        gfm = 0;
    end
    local fBusy = gfm + work;
    local available = numActiveFollowers - fBusy;
        
    
    -- Missions Available --
    local AvailableItems = C_Garrison.GetAvailableMissions();
    
    -- Missions Complete --
    local completeMissions = C_Garrison.GetCompleteMissions();
    
    -- Missions in Progress --
    local items = C_Garrison.GetLandingPageItems();  
    local mip = #items - #completeMissions;

    -- Mining and Herb Nodes --
    local mines = {61, 62, 63}
	local gardens = {29, 136, 137}
	local buildings, myMine, myGarden = C_Garrison.GetBuildings()
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		for k, v in ipairs(mines) do
			if v == buildingID then
				myMine = v
			end
		end
		for k, v in ipairs(gardens) do
			if v == buildingID then
				myGarden = v
			end
		end
	end
	if myMine == 61 then
        if GarrisonDone_Varsc.character.hasMine then
	--	if GarrisonDone_Varsc.character.miningLeft > 0 then
		ore = 8; --format("%s", GarrisonDone_Varsc.character.miningLeft)
        --    tonumber(ore)
	--	end
	end 
        ores = 8;
    elseif myMine == 62 then
        if GarrisonDone_Varsc.character.hasMine then
	--	if GarrisonDone_Varsc.character.miningLeft > 0 then
		ore = 13; -- format("%s", GarrisonDone_Varsc.character.miningLeft)
        --    tonumber(ore)
	--	end
	end 
        ores = 13;
    elseif myMine == 63 then
        if GarrisonDone_Varsc.character.hasMine then
	--	if GarrisonDone_Varsc.character.miningLeft > 0 then
		ore = 18; -- format("%s", GarrisonDone_Varsc.character.miningLeft)
        --    tonumber(ore)
	--	end
	end 
        ores = 18;
    end
	if myGarden == 29 then
    --    if GarrisonDone_Varsc.character.hasGarden then
	--	if GarrisonDone_Varsc.character.herbingLeft > 0 then
		herb = 6; -- format("%s", GarrisonDone_Varsc.character.herbingLeft)
    --        tonumber(herb)
	--	end
--	end 
        herbs = 6;
    elseif myGarden == 136 then
    --    if GarrisonDone_Varsc.character.hasGarden then
	--	if GarrisonDone_Varsc.character.herbingLeft > 0 then
		herb = 10; -- format("%s", GarrisonDone_Varsc.character.herbingLeft)
        --    tonumber(herb)
	--	end
--	end 
        herbs = 10;
    elseif myGarden == 137 then
    --    if GarrisonDone_Varsc.character.hasGarden then
	--	if GarrisonDone_Varsc.character.herbingLeft > 0 then
		herb = 15; -- format("%s", GarrisonDone_Varsc.character.herbingLeft)
    --        tonumber(herb)
	--	end
--	end 
        herbs = 15;
	end
    
    
    -- Garrison Resources --
    local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);

    
    
    
	-- Set Contents Main Frame --
	if (GarrisonDoneEditBox:IsShown()) then
		GarrisonDonePageName:SetText(""..playerName.."'s  Garrison");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDTFPageName:SetText("Total Followers|cff007fff = |r"..numActiveFollowers.."|cff007fff/|r"..maxFollowers.."");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDMCPageName:SetText("Missions Complete|cff007fff = |cff00aa00"..#completeMissions.."");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
        if mip ~= 0 then
		MGDFMPageName:SetText("Missions in Progress|cff007fff = |r"..mip.."");
        elseif mip == 0 then
        MGDFMPageName:SetText("Missions in Progress|cff007fff = |r|cffff0000"..mip.."");
            end
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDMAPageName:SetText("Missions Available|cff007fff = |r"..#AvailableItems.."");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDFAPageName:SetText("Followers Available|cff007fff = |r"..available.."");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDFWPageName:SetText("Followers Working|cff007fff = |r"..work.."");
        end
                
    if (GarrisonDoneEditBox:IsShown()) then
        if ore ~= 0 then
		MGDMNPageName:SetText("Mining Nodes|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."");
        elseif ore == 0 then
        MGDMNPageName:SetText("Mining Nodes|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."");
            end
        end
             
    if (GarrisonDoneEditBox:IsShown()) then
        if herb ~= 0 then
		MGDHNPageName:SetText("Nice Flowers|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
        elseif herb == 0 then
        MGDHNPageName:SetText("Nice Flowers|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
            end
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDGRPageName:SetText("Garrison Resource|cff007fff = |r"..currentAmount.."");
        end
        
        GarrisonDoneEditBox:SetWidth(GarrisonDoneFrame:GetWidth()-50) -- might be to much --

        -- add other stuff we need to update later here --
    
end


--[[

        -- Second Frame for Alt's Mission Status --
function GarrisonDoneA_Update()
    -- Assign Local Variables straight from Blizz frame --        
    
    -- Missions Available --
    -- local AvailableItems = C_Garrison.GetAvailableMissions();
    
    -- Missions Complete --
  --  local completeMissions = C_Garrison.GetCompleteMissions();
    
    -- Missions in Progress --
  --  local items = C_Garrison.GetLandingPageItems();  
 --   local mip = #items - #completeMissions;

       
	-- Set Contents Alt Frame --
	
    if (GarrisonDoneAEditBox:IsShown()) then
		MGDPNPageName:SetText(""..playersName.."'s  Garrison");
        end
            
    if (GarrisonDoneAEditBox:IsShown()) then
		MGDAFMPageName:SetText("Missions in Progress|cff007fff = |r 0");
        end
    
    if (GarrisonDoneAEditBox:IsShown()) then
		MGDAMAPageName:SetText("Missions Available|cff007fff = |r 0");
        end
    
    if (GarrisonDoneAEditBox:IsShown()) then
		MGDAMCPageName:SetText("Missions Complete|cff007fff = |cff00aa00 TEST");
        end
        
        GarrisonDoneAEditBox:SetWidth(GarrisonDoneFrame:GetWidth()-50)
   
        -- add in pairs for multi toons later here --
end
]]--


function GarrisonDone_SetText()
	-- SET TEXT we want it to set the correct text in the right place and this might not be the most efficient way --
	-- GarrisonDoneEditBox:SetText("Test Text");
	
end

function GarrisonDone_StoreText(playSoundFx)
	-- SAVE TEXT we are going to want to save certain variables to display again  --
	-- GarrisonDone_Varsc.w = GarrisonDoneEditBox:GetText(); --
	
end

  --[[
-- UNREGISTER EVENTS --
        GarrisonDone:UnregisterEvent("VARIABLES_LOADED");
        GarrisonDone:UnregisterEvent("STORETEXT");
        GarrisonDone:UnregisterEvent("ONTEXTCHANGED");
        GarrisonDone:UnregisterEvent("UPDATE");
        GarrisonDone:UnregisterEvent("GETTEXT");
        GarrisonDone:UnregisterEvent("SETTEXT");
        GarrisonDone:UnregisterEvent("ONFOCUS");
        GarrisonDone:UnregisterEvent("SETFOCUS");
        GarrisonDone:UnregisterEvent("CLEARFOCUS");
        GarrisonDone:UnregisterEvent("ONSHOW");
        GarrisonDone:UnregisterEvent("ONHIDE");
        GarrisonDone:UnregisterEvent("ONCLICK");
        GarrisonDone:UnregisterEvent("ZONE_CHANGED");
        GarrisonDone:UnregisterEvent("ZONE_CHANGED_INDOORS");
        GarrisonDone:UnregisterEvent("ZONE_CHANGED_NEW_AREA");
        GarrisonDone:UnregisterEvent("REGISTERFORDRAG");
        GarrisonDone:UnregisterEvent("GARRISON_UPDATE");
        GarrisonDone:UnregisterEvent("GARRISON_FOLLOWER_WORKING");
        GarrisonDone:UnregisterEvent("GARRISON_MISSION_LIST_UPDATE");
        GarrisonDone:UnregisterEvent("CURRENCY_DISPLAY_UPDATE");
        GarrisonDone:UnregisterEvent("GARRISON_MISSION_STARTED");
        GarrisonDone:UnregisterEvent("GARRISON_MISSION_FINISHED");
        GarrisonDone:UnregisterEvent("CHAT_MSG_SYSTEM");
	    GarrisonDone:UnregisterEvent("GARRISON_FOLLOWER_ADDED");
	    GarrisonDone:UnregisterEvent("GARRISON_FOLLOWER_LIST_UPDATE");
	    GarrisonDone:UnregisterEvent("GARRISON_FOLLOWER_REMOVED");
	    GarrisonDone:UnregisterEvent("GARRISON_HIDE_LANDING_PAGE");
	    GarrisonDone:UnregisterEvent("GARRISON_MISSION_NPC_CLOSED");
	    GarrisonDone:UnregisterEvent("GARRISON_MISSION_NPC_OPENED");
	    GarrisonDone:UnregisterEvent("GARRISON_SHOW_LANDING_PAGE");
        GarrisonDone:UnregisterEvent("PLAYER_ENTERING_WORLD");
        ]]-- 


   



 -- LDB LAUNCHER --
            -- might change this to ldb display -- or better add Ldb Display --
    
    local GarrisonDone_Varsc = GarrisonDone_Varsc
    local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1")
    
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "launcher",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button)
            if (button == "LeftButton") then
            if GarrisonDoneFrame:IsVisible() then
		        GarrisonDoneFrame:Hide()
	        else
		        GarrisonDoneFrame:Show()
	        end
            elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("GarrisonDone") 
        end
    end,
            OnTooltipShow = function(tooltip)
                tooltip:AddLine('My Garrison is Done ('..GarrisonDone_Version..')')
                tooltip:AddLine('|cffffff00Left click for My Garrison Panel')
                tooltip:AddLine('|cffffff00Right Click for Interface Panel')
            end,
        })


 

   -- INTERFACE OPTIONS MENU -- 
    
   -- FRAME 1 --
  
   
    
	local garrisondone = CreateFrame("Frame", "GarrisonDone", UIParent)
	garrisondone:Hide()
    garrisondone:IsResizable(true)
    garrisondone:SetMinResize(350,250)
	garrisondone.name = "My Garrison"
    garrisondone:SetBackdropColor(0, 0, 0, 1)
	garrisondone:SetWidth(250)
	garrisondone:SetHeight(400)
	garrisondone:SetPoint("CENTER", UIParent, "CENTER")
	InterfaceOptions_AddCategory(garrisondone)

	local title = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -20)
	title:SetText("My Garrison is Done ("..GarrisonDone_Version..")" )
 
    
    local mgdEditBox = CreateFrame("EditBox", "GarrisonDoneEditBox", garrisondone)
    mgdEditBox:SetPoint ("TOPLEFT",26,-42)
	mgdEditBox:EnableMouse(false)
	mgdEditBox:SetAutoFocus(false)
	mgdEditBox:SetFontObject(GameFontNormal)
	mgdEditBox:SetWidth(450)
	mgdEditBox:SetHeight(120)
    mgdEditBox:SetText("")
	mgdEditBox:Show()
    
    local mgdEditBoxText = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -5)
	mgdEditBoxText:SetWidth(420)
	mgdEditBoxText:SetHeight(110)
    mgdEditBoxText:SetFontObject(GameFontHighlight)
    mgdEditBoxText:SetJustifyH("LEFT")
	mgdEditBoxText:SetText("Garrison Done")
    
    local mgdEditBoxText2 = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -115)
	mgdEditBoxText2:SetWidth(420)
	mgdEditBoxText2:SetHeight(110)
    mgdEditBoxText2:SetFontObject(GameFontHighlight)
    mgdEditBoxText2:SetJustifyH("LEFT")
	mgdEditBoxText2:SetText(" xml. |cff007fffJaxom of Hellfire EU")
      

     -- OPTIONS TITLE --
    
    local mgdtitle = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontHighlightLarge")
	mgdtitle:SetPoint("TOPLEFT", 16, -287)
	mgdtitle:SetText("|cff007fffOptions")       
                    
    -- HIDE BUTTON --
    
    local mgdmini = CreateFrame("CheckButton", "GarrisonDoneButton1", garrisondone)
	mgdmini:SetWidth(26)
	mgdmini:SetHeight(26)
	mgdmini:SetPoint("TOPLEFT", 16, -317)
--    gdmini:SetChecked(GarrisonDone_Varsc.button == false)
    mgdmini:SetScript("OnClick", function(self)
            if self:GetChecked() then
    --        GarrisonDone_Vars.button = false
    --        MGD_Button:Show()
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Button is now ON");
            else
    --        GarrisonDone_Vars.button = true
    --        MGD_Button:Hide()
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Button is now OFF");
            end
	end--function
    )
    
   
	mgdmini:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	mgdmini:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	mgdmini:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	mgdmini:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local mgdminiText = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlight")
	mgdminiText:SetPoint("LEFT", mgdmini, "RIGHT", 0, 2)
	mgdminiText:SetText("|CFF00AA00Show/Hide Garrison Button|r")
    
    local mgdminiText2 = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlightSmall")
	mgdminiText2:SetPoint("LEFT", mgdmini, "RIGHT", 5, -10)
    mgdminiText2:SetText("LDB Slidebar Icon and Titan Panel is Available")
    
    
     -- DISABLE AUTO OPEN --
    
    local mgdauto = CreateFrame("CheckButton", "GarrisonDoneButton1", garrisondone)
	mgdauto:SetWidth(26)
	mgdauto:SetHeight(26)
	mgdauto:SetPoint("TOPLEFT", 16, -347)
    mgdauto:SetChecked(GarrisonDone_Varsc.button == false)
    mgdauto:SetScript("OnClick", function(self)
            if self:GetChecked() then
            GarrisonDone_Varsc.auto = false
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto open is now OFF");
            else
            GarrisonDone_Varsc.auto = true
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto Open is now ON");
            end
	end--function
    )
    
   
	mgdauto:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	mgdauto:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	mgdauto:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	mgdauto:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local mgdautoText = mgdauto:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlight")
	mgdautoText:SetPoint("LEFT", mgdauto, "RIGHT", 0, 2)
	mgdautoText:SetText("|CFF00AA00Turn OFF Auto Open Garrison Frame|r")
    
    local mgdautoText2 = mgdauto:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlightSmall")
	mgdautoText2:SetPoint("LEFT", mgdmini, "RIGHT", 5, -10)
    mgdautoText2:SetText("The Garrison Frame is Default set to Auto Open When you are in your Garrison")
    
   -- Add other options as we think of them --
    
    
